/*
 * Player.java
 *
 * Created on 24 November 2006, 07:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pishti;

import java.util.Vector;

/**
 *
 * @author onur
 */
public abstract class Player implements TableObserver {
    
    public static final int PLAYER1 = 1;
    public static final int PLAYER2 = 2;
    public static final int PLAYER3 = 3;
    public static final int PLAYER4 = 4;
    
    protected Vector hand = null;
    private int points = 0;
    private String name;
    private int id;
    
    /** Creates a new instance of Player */
    public Player(int id, String name)
    {
        this.id = id;
        this.name = name;
    }
    
    public final int getId()
    {
        return id;
    }
    
    public final String getName()
    {
        return name;
    }
    
    public final Card throwCard()
    {
        Card t = selectCardToThrow();
        hand.removeElement(t); // ToDo: check if selection is valid.
        return t;
    }
    
    public final void addPoints(int newPoints)
    {
        points += newPoints;
    }
    
    public final int getPoints()
    {
        return points;
    }
    
    protected abstract Card selectCardToThrow();
    
    public void setHand(Vector hand)
    {
        if(PishtiVisualiserApplet.DEBUG) System.out.println("Player " + getName() + " is given " + hand);
        this.hand = hand;
    }

    public abstract void notifyTableEvent(TableEvent evt);    

}
