/*
 * Table.java
 *
 * Created on 24 November 2006, 07:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pishti;

import java.util.Iterator;
import java.util.Stack;
import java.util.Vector;

/**
 *
 * @author onur
 */
public class Table {
    
    private Vector observers;
    private Stack cards;
    
    /** Creates a new instance of Table */
    public Table() 
    {
        observers = new Vector();
        cards = new Stack();
    }
    
    public void addObserver(TableObserver to)
    {
        observers.add(to);
    }
    
    public void removeObserver(TableObserver to)
    {
        observers.removeElement(to);
    }
    
    public void putInitialFourCards(Vector v)
    {
        cards.removeAllElements();
        cards.push(v.elementAt(0));
        cards.push(v.elementAt(1));
        cards.push(v.elementAt(2));
        cards.push(v.elementAt(3));
        CardThrownEvent cte = new CardThrownEvent( (Card)v.elementAt(3) );
        notifyObservers(cte);
    }
    
    public void put(Card thrown)
    {
        boolean cleanTable = false;
        if(!cards.isEmpty())
        {
            Card onTop = (Card)cards.peek();
            
            if( onTop.getValue() == thrown.getValue() || thrown.getValue() == 11)
                cleanTable = true;
        }
        
        
        cards.push(thrown);
        CardThrownEvent cte = new CardThrownEvent(thrown);
        notifyObservers(cte);
        
        if(cleanTable)
            cleanTable();
    }
    
    private void notifyObservers(TableEvent evt)
    {
        for(Iterator it = observers.iterator(); it.hasNext();)
            ((TableObserver)it.next()).notifyTableEvent(evt);
    }
    
    public int calculatePointsOnTable()
    {
        int points = 0;
        
        if( cards.size() == 2 && ((Card)cards.elementAt(0)).getValue() == ((Card)cards.elementAt(1)).getValue() )
        {
            if( ((Card)cards.peek()).getValue() == 11 )
            {
                points += 20;
                if(PishtiVisualiserApplet.DEBUG)
                    System.out.println("Joker Pisti");
            }
            else
            {
                points += 10;
                if(PishtiVisualiserApplet.DEBUG)
                    System.out.println("Pisti");            
            }
        }
        
        for(Iterator it = cards.iterator(); it.hasNext();)
        {
            Card c = (Card)it.next();
            if( c.getValue() == 1 || c.getValue() == 11)
                points += 1;
            else if(c.getType() == Card.CLUBS && c.getValue() == 2)
                points += 2;
            else if( c.getType() == Card.DIAMONDS && c.getValue() == 10 )
                points += 3;
            
        }
        return points;
    }
    
    public void cleanTable()
    {
        TableCleanedEvent tce = new TableCleanedEvent( calculatePointsOnTable(), cards.size() );
        notifyObservers(tce);
        cards.removeAllElements();
    }
    
}
